<!---
An XHTML valid version of ParagraphFormat, based on ParagraphFormat2 by Ben Forta, Mark R Andrachek, and Nathan Dintenfas.

@param string 	 The string to format. (Required)
@return Returns a string. 
@author Joe Lencioni (joe@gustavus.edu) 
@version 2, February 7, 2006 
--->

<cffunction name="XHTMLParagraphFormat" returntype="string" output="false">
		<cfargument name="str" required="true" type="string">
		
		<cfset var returnString			= arguments.str & chr(10) & chr(10)>
		<cfset var regularExpression	= "">
		<cfset var subString			= "">
		<cfset var tagsList				= "h\d|h|p|div|ul|ol|li|pre|blockquote|blockcode|code|table|tr|td|th|dl|dt|dd|address|hr|section|form">
		
		<cfif trim(returnString) is not "">
			
			<!--- first make Windows style into Unix style --->
			<cfset returnString			= replace(returnString, chr(13) & chr(10), chr(10), "ALL")>
			
			<!--- now make Macintosh style into Unix style --->
			<cfset returnString			= replace(returnString, chr(13), chr(10), "ALL")>
	
			<!--- now fix tabs --->
			<cfset returnString			= replace(returnString, chr(9), "&nbsp;&nbsp;&nbsp;", "ALL")>
			
			<!--- convert newlines to <br/> --->
			<cfset returnString			= replace(returnString, chr(10), "<br/>#chr(10)#", "ALL")>
			
			<!--- convert text followed by two <br/> tags into <p>text</p> --->
			<cfset regularExpression	= "(.*?(?=<br/>([\r\n]*)?))(<br/>([\r\n]*)?)(<br/>([\r\n]*)?)">
			<cfset subString			= "#chr(10)#<p>\1</p>#chr(10)#">
			
			<cfset returnString			= REReplaceNoCase(returnString, regularExpression, subString, "ALL")>
			
			<!--- remove extra paragraph tags --->
			<cfset regularExpression	= "<p>(<(#tagsList#)([^>]*)>(.*?)</(#tagsList#)>)</p>">
			<cfset subString			= "\1">
			
			<cfset returnString			= REReplaceNoCase(returnString, regularExpression, subString, "ALL")>
			
			<!--- remove extra <br/> tags --->
			<cfset regularExpression	= "(</?(#tagsList#)([^>]*)>)(<br/>*)">
			<cfset subString			= "\1">
			
			<cfset returnString			= REReplaceNoCase(returnString, regularExpression, subString, "ALL")>
		</cfif>
		
		<cfreturn returnString>
	</cffunction>